package com.bwie.auth.feign.impl;

import com.bwie.auth.feign.AuthFeign;
import com.bwie.common.domain.User;
import com.bwie.common.result.Result;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;

@Component
public class AuthFeignImpl implements FallbackFactory<AuthFeign> {
    @Override
    public AuthFeign create(Throwable cause) {
        return new AuthFeign() {
            @Override
            public Result<User> findUserByName(String userName) {
                return Result.error("熔断失败");
            }
        };
    }
}
