package com.bwie.common.execption;

import lombok.extern.log4j.Log4j2;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RestControllerAdvice;

import java.util.concurrent.TimeoutException;

@RestControllerAdvice
@Log4j2
public class HandExecption {

    @ExceptionHandler(value = TimeoutException.class)
    public String findExecptino(Throwable throwable){
        StackTraceElement stackTraceElement = throwable.getStackTrace()[0];
        int lineNumber = stackTraceElement.getLineNumber();
        String fileName = stackTraceElement.getFileName();
        String className = stackTraceElement.getClassName();
        String moduleName = stackTraceElement.getModuleName();
        log.info("报错模块名换"+moduleName+"报错文件名称"+fileName+"报错类名称"+className+"行数"+lineNumber);
        return "失败";
    }
}
