package com.bwie.rabbitmq.consumer;


import com.bwie.common.domain.User;
import com.bwie.common.utils.TelSmsUtils;
import com.rabbitmq.client.Channel;
import lombok.extern.log4j.Log4j2;
import org.springframework.amqp.core.Message;
import org.springframework.amqp.rabbit.annotation.Queue;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.util.HashMap;

@Component
@Log4j2
public class MsgConsumer {
 @Autowired
 private StringRedisTemplate stringRedisTemplate;
    @RabbitListener(queuesToDeclare = {@Queue("send_msg")})
    public void sendMsg(User user, Message message, Channel channel){
        String messageId = message.getMessageProperties().getMessageId();
        try {
            Long messagesId = stringRedisTemplate.opsForSet().add("messagesId", messageId);
            HashMap<String, String> stringStringHashMap = new HashMap<>();
            stringStringHashMap.put("code","审核完成请注意查收");
            //发送消息
            TelSmsUtils.sendSms(user.getUserPhone(),stringStringHashMap);
            if(messagesId==1){
                channel.basicAck(message.getMessageProperties().getDeliveryTag(),false);
            }

        } catch (IOException e) {
            stringRedisTemplate.opsForSet().remove("messagesId",messageId);
            try {
                channel.basicReject(message.getMessageProperties().getDeliveryTag(),true);
            } catch (IOException ex) {
                throw new RuntimeException(ex);
            }
        }

    }
}
